Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Attributes
Lucene::ConstantScoreAutoRewrite Class Reference

A rewrite method that tries to pick the best constant-score rewrite method based on term and document counts from the query. If both the number of terms and documents is small enough, then CONSTANT_SCORE_BOOLEAN_QUERY_REWRITE is used. Otherwise, CONSTANT_SCORE_FILTER_REWRITE is used. More...

`#include <MultiTermQuery.h>`

Inheritance diagram for Lucene::ConstantScoreAutoRewrite:

## Public Member Functions

| ConstantScoreAutoRewrite ()
virtual | ~ConstantScoreAutoRewrite ()
virtual String | getClassName ()
boost::shared_ptr < ConstantScoreAutoRewrite > | shared_from_this ()
virtual void | setTermCountCutoff (int32_t count)
| If the number of terms in this query is equal to or larger than this setting then CONSTANT_SCORE_FILTER_REWRITE is used. More...
virtual int32_t | getTermCountCutoff ()
virtual void | setDocCountPercent (double percent)
| If the number of documents to be visited in the postings exceeds this specified percentage of the maxDoc() for the index, then CONSTANT_SCORE_FILTER_REWRITE is used. More...
virtual double | getDocCountPercent ()
virtual QueryPtr | rewrite (IndexReaderPtr reader, MultiTermQueryPtr query)
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (LuceneObjectPtr other)
| Return whether two objects are equal. More...
Public Member Functions inherited from Lucene::RewriteMethod
virtual | ~RewriteMethod ()
boost::shared_ptr< RewriteMethod > | shared_from_this ()
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (LuceneObjectPtr other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | compareTo (LuceneObjectPtr other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::RewriteMethod
static String | _getClassName ()

## Static Public Attributes

static const int32_t | DEFAULT_TERM_COUNT_CUTOFF
static const double | DEFAULT_DOC_COUNT_PERCENT

## Protected Attributes

int32_t | termCountCutoff
double | docCountPercent

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Detailed Description

A rewrite method that tries to pick the best constant-score rewrite method based on term and document counts from the query. If both the number of terms and documents is small enough, then CONSTANT_SCORE_BOOLEAN_QUERY_REWRITE is used. Otherwise, CONSTANT_SCORE_FILTER_REWRITE is used.

## Constructor & Destructor Documentation

Lucene::ConstantScoreAutoRewrite::ConstantScoreAutoRewrite | ( | ) |  |

virtual Lucene::ConstantScoreAutoRewrite::~ConstantScoreAutoRewrite | ( | ) |  |

virtual

## Member Function Documentation

static String Lucene::ConstantScoreAutoRewrite::_getClassName | ( | ) |  |

inline static

virtual bool Lucene::ConstantScoreAutoRewrite::equals | ( | LuceneObjectPtr | other) |  |

virtual

Return whether two objects are equal.

Reimplemented from Lucene::LuceneObject.

virtual String Lucene::ConstantScoreAutoRewrite::getClassName | ( | ) |  |

inline virtual

Reimplemented from Lucene::RewriteMethod.

virtual double Lucene::ConstantScoreAutoRewrite::getDocCountPercent | ( | ) |  |

virtual

See Also
  setDocCountPercent

virtual int32_t Lucene::ConstantScoreAutoRewrite::getTermCountCutoff | ( | ) |  |

virtual

See Also
  setTermCountCutoff

virtual int32_t Lucene::ConstantScoreAutoRewrite::hashCode | ( | ) |  |

virtual

Return hash code for this object.

Reimplemented from Lucene::LuceneObject.

virtual QueryPtr Lucene::ConstantScoreAutoRewrite::rewrite | ( | IndexReaderPtr | reader,
|  | MultiTermQueryPtr | query
| ) |  |

virtual

Implements Lucene::RewriteMethod.

virtual void Lucene::ConstantScoreAutoRewrite::setDocCountPercent | ( | double | percent) |  |

virtual

If the number of documents to be visited in the postings exceeds this specified percentage of the maxDoc() for the index, then CONSTANT_SCORE_FILTER_REWRITE is used.

Parameters

  percent | 0.0 to 100.0

virtual void Lucene::ConstantScoreAutoRewrite::setTermCountCutoff | ( | int32_t | count) |  |

virtual

If the number of terms in this query is equal to or larger than this setting then CONSTANT_SCORE_FILTER_REWRITE is used.

boost::shared_ptr< ConstantScoreAutoRewrite > Lucene::ConstantScoreAutoRewrite::shared_from_this | ( | ) |  |

inline

## Field Documentation

const double Lucene::ConstantScoreAutoRewrite::DEFAULT_DOC_COUNT_PERCENT

static

const int32_t Lucene::ConstantScoreAutoRewrite::DEFAULT_TERM_COUNT_CUTOFF

static

double Lucene::ConstantScoreAutoRewrite::docCountPercent

protected

int32_t Lucene::ConstantScoreAutoRewrite::termCountCutoff

protected

The documentation for this class was generated from the following file:

- MultiTermQuery.h

clucene.sourceforge.net